#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
from array import *
#import Numeric
import subprocess

from pyLoc import *


# This script sum all the rtm files 
# with the option to take an additional laplacian

# naxis: number of axes in files to be summed
naxis=2
savDir = 'rtm/SA'
plet='SAdec'
sbin = "bin"

nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='1:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job
jobname = 'rtmsum%s_'%(plet) # Job name 



if (os.path.isdir('%s/pbs'%(savDir)) != 1):
	os.system('mkdir %s/pbs'%(savDir))
if (os.path.isdir('%s/logfile'%(savDir)) != 1):
	os.system('mkdir %s/logfile'%(savDir))
cmdfile = "%s/pbs/PBS%s.txt"%(savDir,plet)
logfile = "%s/logfile/rtmsum%s.txt"%(savDir,plet)
os.system("rm -f %s %s"%(cmdfile,logfile))



# Calculate number of blocks
nblock = len(K)/10           # sum 10 shots at a Time
nLB = len(K) - nblock*10
if (nLB == 0):        	
	nLB = 10
else:
	nblock = len(K)/10+1
        		
# Calculating the first nblock-1 blocks, 10 files per block
for block in range(1,nblock):
	print 'summing Block #', block 
	k = (block-1)*10
	cmd1 = "%s/SUMMING.x nfile=10 naxis=%s outfile=%s/rtm%s_block%s.H "%(sbin,naxis,savDir,plet,block)
	cmd1UU = "%s/SUMMING.x nfile=10 naxis=%s outfile=%s/rtm%sUU_block%s.H "%(sbin,naxis,savDir,plet,block)
	cmd1UD = "%s/SUMMING.x nfile=10 naxis=%s outfile=%s/rtm%sUD_block%s.H "%(sbin,naxis,savDir,plet,block)
	for i in range(1,10+1):
		cmd1 = cmd1+ "file%s=%s/rtm%s%s.H "%(i, savDir,plet,K[k+i-1])
		cmd1UU = cmd1UU+ "file%s=%s/rtm%s%sUUDD.H "%(i, savDir,plet,K[k+i-1])
		cmd1UD = cmd1UD+ "file%s=%s/rtm%s%sUDDU.H "%(i, savDir,plet,K[k+i-1])
	cmd1 = cmd1+' >/dev/null'	
	cmd1UU = cmd1UU+' >/dev/null'	
	cmd1UD = cmd1UD+' >/dev/null'	
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UD,cmdfile))


# Calculate the last block, contains nLB files
  	print 'Block #', nblock
	block = nblock	
	i = (block-1)*10+1
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%s_block%s.H "%(sbin,nLB,naxis,savDir,plet,block)
	cmd1UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUU_block%s.H "%(sbin,nLB,naxis,savDir,plet,block)
	cmd1UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUD_block%s.H "%(sbin,nLB,naxis,savDir,plet,block)
	for i in range(1,nLB+1):
    			cmd1=cmd1+' file%s=%s/rtm%s%s.H '%(i,savDir,plet,K[i-1+len(K)-nLB])    	
    			cmd1UU=cmd1UU+' file%s=%s/rtm%s%sUUDD.H '%(i,savDir,plet,K[i-1+len(K)-nLB])    	
    			cmd1UD=cmd1UD+' file%s=%s/rtm%s%sUDDU.H '%(i,savDir,plet,K[i-1+len(K)-nLB])    	
	cmd1= cmd1+' >/dev/null'
	cmd1UU= cmd1UU+' >/dev/null'
	cmd1UD= cmd1UD+' >/dev/null'
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UD,cmdfile))
    		
                 	  	  	  	
# Sum all the block to form a big model, assume nblock <= 30 
if (nblock < 11): 
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sTotal.H "%(sbin,nblock, naxis, savDir,plet)
	cmd1UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUUDDTotal.H "%(sbin,nblock, naxis, savDir,plet)
	cmd1UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUDDUTotal.H "%(sbin,nblock, naxis, savDir,plet)
	cmd2 = "python ~/Setup/pyRemove.py "
	for i in range(1, nblock+1):
		cmd1 = cmd1 + ' file%s=%s/rtm%s_block%s.H'%(i,savDir,plet,i)
		cmd1UU = cmd1UU + ' file%s=%s/rtm%sUU_block%s.H'%(i,savDir,plet,i)
		cmd1UD = cmd1UD + ' file%s=%s/rtm%sUD_block%s.H'%(i,savDir,plet,i)
		cmd2 = cmd2 + ' %s/rtm%s_block%s.H'%(savDir,plet,i)
	cmd1 = cmd1 + ' >/dev/null' 
	cmd1UU = cmd1UU + ' >/dev/null' 
	cmd1UD = cmd1UD + ' >/dev/null' 
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UD,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))
elif ( (nblock > 10) & (nblock < 21)):
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%s_superbk1.H "%(sbin,10, naxis, savDir,plet)
	cmd1UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUU_superbk1.H "%(sbin,10, naxis, savDir,plet)
	cmd1UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUD_superbk1.H "%(sbin,10, naxis, savDir,plet)
	cmd2 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%s_superbk2.H "%(sbin,nblock-10, naxis, savDir,plet)
	cmd2UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUU_superbk2.H "%(sbin,nblock-10, naxis, savDir,plet)
	cmd2UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUD_superbk2.H "%(sbin,nblock-10, naxis, savDir,plet)
	erase = "python ~/Setup/pyRemove.py "
	for i in range(1, 10+1):
		cmd1 = cmd1 + ' file%s=%s/rtm%s_block%s.H'%(i,savDir,plet,i)
		cmd1UU = cmd1UU + ' file%s=%s/rtm%sUU_block%s.H'%(i,savDir,plet,i)
		cmd1UD = cmd1UD + ' file%s=%s/rtm%sUD_block%s.H'%(i,savDir,plet,i)
		erase = erase + ' %s/rtm%s_block%s.H'%(savDir,plet,i)
	for i in range(1, nblock-10+1):
		cmd2 = cmd2 + ' file%s=%s/rtm%s_block%s.H'%(i,savDir,plet,i+10)
		cmd2UU = cmd2UU + ' file%s=%s/rtm%sUU_block%s.H'%(i,savDir,plet,i+10)
		cmd2UD = cmd2UD + ' file%s=%s/rtm%sUD_block%s.H'%(i,savDir,plet,i+10)
		erase = erase + ' %s/rtm%s_block%s.H'%(savDir,plet,i)
	cmd1 = cmd1 + ' >/dev/null' 
	cmd1UU = cmd1UU + ' >/dev/null' 
	cmd1UD = cmd1UD + ' >/dev/null' 
	cmd2 = cmd2 + ' >/dev/null' 
	cmd2UU = cmd2UU + ' >/dev/null' 
	cmd2UD = cmd2UD + ' >/dev/null' 
	# sum the superblocks together
	cmd3 = "%s/SUMMING.x nfile=2 naxis=%s file1=%s/rtm%s_superbk1.H file2=%s/rtm%s_superbk2.H outfile=%s/rtm%sTotal.H "%(sbin, naxis, savDir,plet,savDir,plet,savDir,plet)
	cmd3UU = "%s/SUMMING.x nfile=2 naxis=%s file1=%s/rtm%sUU_superbk1.H file2=%s/rtm%sUU_superbk2.H outfile=%s/rtm%sUUDDTotal.H "%(sbin, naxis, savDir,plet,savDir,plet,savDir,plet)
	cmd3UD = "%s/SUMMING.x nfile=2 naxis=%s file1=%s/rtm%sUD_superbk1.H file2=%s/rtm%sUD_superbk2.H outfile=%s/rtm%sUDDUTotal.H "%(sbin, naxis, savDir,plet,savDir,plet,savDir,plet)
	erase = erase + ' %s/rtm%s_superbk1.H %s/rtm%s_superbk2.H'%(savDir,plet,savDir,plet)
	erase = erase + ' %s/rtm%sUU_superbk1.H %s/rtm%sUU_superbk2.H'%(savDir,plet,savDir,plet)
	erase = erase + ' %s/rtm%sUD_superbk1.H %s/rtm%sUD_superbk2.H'%(savDir,plet,savDir,plet)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UD,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2UD,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3UD,cmdfile))
	os.system("echo '%s' >> %s"%(erase,cmdfile))
elif ( (nblock > 20) & (nblock < 31)):
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%s_superbk1.H "%(sbin,10, naxis, savDir,plet)
	cmd2 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%s_superbk2.H "%(sbin,10, naxis, savDir,plet)
	cmd3 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%s_superbk3.H "%(sbin,nblock-20, naxis, savDir,plet)
	cmd1UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUU_superbk1.H "%(sbin,10, naxis, savDir,plet)
	cmd2UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUU_superbk2.H "%(sbin,10, naxis, savDir,plet)
	cmd3UU = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUU_superbk3.H "%(sbin,nblock-20, naxis, savDir,plet)
	cmd1UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUD_superbk1.H "%(sbin,10, naxis, savDir,plet)
	cmd2UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUD_superbk2.H "%(sbin,10, naxis, savDir,plet)
	cmd3UD = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s/rtm%sUD_superbk3.H "%(sbin,nblock-20, naxis, savDir,plet)
	erase = "python ~/Setup/pyRemove.py "
	for i in range(1, 10+1):
		cmd1 = cmd1 + ' file%s=%s/rtm%s_block%s.H'%(i,savDir,plet,i)
		cmd2 = cmd2 + ' file%s=%s/rtm%s_block%s.H'%(i,savDir,plet,i+10)
		erase = erase + ' %s/rtm%s_block%s.H %s/rtm%s_block%s.H'%(savDir,plet,i,savDir,plet,i+10)
		cmd1UU = cmd1UU + ' file%s=%s/rtm%sUU_block%s.H'%(i,savDir,plet,i)
		cmd2UU = cmd2UU + ' file%s=%s/rtm%sUU_block%s.H'%(i,savDir,plet,i+10)
		erase = erase + ' %s/rtm%sUU_block%s.H %s/rtm%sUU_block%s.H'%(savDir,plet,i,savDir,plet,i+10)
		cmd1UD = cmd1UD + ' file%s=%s/rtm%sUD_block%s.H'%(i,savDir,plet,i)
		cmd2UD = cmd2UD + ' file%s=%s/rtm%sUD_block%s.H'%(i,savDir,plet,i+10)
		erase = erase + ' %s/rtm%sUD_block%s.H %s/rtm%sUD_block%s.H'%(savDir,plet,i,savDir,plet,i+10)
	for i in range(1, nblock-20+1):
		cmd3 = cmd3 + ' file%s=%s/rtm%s_block%s.H'%(i,savDir,plet,i+20)
		erase = erase + ' %s/rtm%s_block%s.H'%(savDir,plet,i)
		cmd3UU = cmd3UU + ' file%s=%s/rtm%sUU_block%s.H'%(i,savDir,plet,i+20)
		erase = erase + ' %s/rtm%sUU_block%s.H'%(savDir,plet,i)
		cmd3UD = cmd3UD + ' file%s=%s/rtm%sUD_block%s.H'%(i,savDir,plet,i+20)
		erase = erase + ' %s/rtm%sUD_block%s.H'%(savDir,plet,i)
	cmd1 = cmd1 + ' >/dev/null' 
	cmd2 = cmd2 + ' >/dev/null' 
	cmd3 = cmd3 + ' >/dev/null' 
	cmd1UU = cmd1UU + ' >/dev/null' 
	cmd2UU = cmd2UU + ' >/dev/null' 
	cmd3UU = cmd3UU + ' >/dev/null' 
	cmd1UD = cmd1UD + ' >/dev/null' 
	cmd2UD = cmd2UD + ' >/dev/null' 
	cmd3UD = cmd3UD + ' >/dev/null' 
	# sum the superblocks together
	cmd4 = "%s/SUMMING.x nfile=3 naxis=%s file1=%s/rtm%s_superbk1.H file2=%s/rtm%s_superbk2.H file3=%s/rtm%s_superbk3.H outfile=%s/rtm%sTotal.H "%(sbin, naxis, savDir,plet,savDir,plet,savDir,plet,savDir,plet)
	erase = erase + ' %s/rtm%s_superbk1.H %s/rtm%s_superbk2.H %s/rtm%s_superbk3.H'%(savDir,plet,savDir,plet,savDir,plet)
	cmd4UU = "%s/SUMMING.x nfile=3 naxis=%s file1=%s/rtm%sUU_superbk1.H file2=%s/rtm%sUU_superbk2.H file3=%s/rtm%sUU_superbk3.H outfile=%s/rtm%sUUDDTotal.H "%(sbin, naxis, savDir,plet,savDir,plet,savDir,plet,savDir,plet)
	erase = erase + ' %s/rtm%sUU_superbk1.H %s/rtm%sUU_superbk2.H %s/rtm%sUU_superbk3.H'%(savDir,plet,savDir,plet,savDir,plet)
	cmd4UD = "%s/SUMMING.x nfile=3 naxis=%s file1=%s/rtm%sUD_superbk1.H file2=%s/rtm%sUD_superbk2.H file3=%s/rtm%sUD_superbk3.H outfile=%s/rtm%sUDDUTotal.H "%(sbin, naxis, savDir,plet,savDir,plet,savDir,plet,savDir,plet)
	erase = erase + ' %s/rtm%sUD_superbk1.H %s/rtm%sUD_superbk2.H %s/rtm%sUD_superbk3.H'%(savDir,plet,savDir,plet,savDir,plet)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3,cmdfile))
	os.system("echo '%s' >> %s"%(cmd4,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd4UU,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1UD,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2UD,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3UD,cmdfile))
	os.system("echo '%s' >> %s"%(cmd4UD,cmdfile))
	os.system("echo '%s' >> %s"%(erase,cmdfile))			

# Submit job to the cluster
cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s %s 0"%(nodes,ppn,walltime,pmem,jobname,cmdfile)
os.system( cmd1)
           	  	  
